function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["value", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useMemo, useState } from "react";
import { Input, Modal, Form } from "antd";
import { isString } from "@pisell/utils";
import { GlobalOutlined } from "@ant-design/icons";
import classNames from "classnames";
import useEngineContext from "../../hooks/useEngineContext";
import { checkIfAllValuesAreEqual, createTranslationText, locales } from "./utils";
import "./index.less";
var defaultGlobal = {
  shopLanguages: {
    primary: "en",
    list: [{
      id: 1,
      code: "zh-CN",
      text: "简体中文",
      primary: 1,
      status: "published"
    }, {
      id: 2,
      code: "en",
      text: "English",
      primary: 0,
      status: "published"
    }, {
      id: 3,
      code: "zh-HK",
      text: "繁體中文",
      primary: 0,
      status: "published"
    }]
  },
  primary_locale: "en"
};
var defaultObj = {};
var Translation = function Translation(props) {
  var _context$appHelper, _store$getState;
  var _props$value = props.value,
    value = _props$value === void 0 ? defaultObj : _props$value,
    onChange = props.onChange,
    others = _objectWithoutProperties(props, _excluded);
  var context = useEngineContext();
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(value),
    _useState4 = _slicedToArray(_useState3, 2),
    _value = _useState4[0],
    set_value = _useState4[1];
  var store = context === null || context === void 0 ? void 0 : (_context$appHelper = context.appHelper) === null || _context$appHelper === void 0 ? void 0 : _context$appHelper.store;
  var _ref = (store === null || store === void 0 ? void 0 : (_store$getState = store.getState()) === null || _store$getState === void 0 ? void 0 : _store$getState.global) || defaultGlobal,
    shopLanguages = _ref.shopLanguages;
  useEffect(function () {
    var _newValue = _objectSpread({}, value);
    if (isString(value)) {
      _newValue = createTranslationText(value);
    }
    set_value(_objectSpread(_objectSpread({}, defaultValue), _newValue));
  }, [value]);
  var currentLocale = useMemo(function () {
    return shopLanguages.primary;
  }, [shopLanguages.primary]);
  var inputValue = useMemo(function () {
    if (isString(value)) {
      return value;
    }
    return value[currentLocale];
  }, [value, currentLocale]);
  var languageList = useMemo(function () {
    return shopLanguages.list;
  }, [shopLanguages.list]);
  var defaultValue = useMemo(function () {
    var obj = {};
    for (var item in locales) {
      obj[item] = "";
    }
    return obj;
  }, []);
  var allChange = function allChange(e) {
    var newValue = _objectSpread(_objectSpread({}, defaultValue), value || {});
    if (checkIfAllValuesAreEqual(newValue)) {
      for (var key in newValue) {
        newValue[key] = e || "";
      }
    } else {
      newValue[currentLocale] = e || "";
    }
    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
  };
  var isActive = useMemo(function () {
    var bol = false;
    for (var key in value) {
      if (key !== currentLocale && value[key]) {
        bol = true;
      }
    }
    return bol;
  }, [value, currentLocale]);
  var _onOk = function _onOk() {
    onChange === null || onChange === void 0 ? void 0 : onChange(_value);
    setOpen(false);
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Input, _extends({}, others, {
    value: inputValue,
    onChange: function onChange(e) {
      return allChange(e.target.value);
    },
    suffix: /*#__PURE__*/React.createElement(GlobalOutlined, {
      className: classNames("pisell-lowcode-translation-icon", {
        active: isActive
      }),
      onClick: function onClick() {
        return setOpen(true);
      }
    })
  })), /*#__PURE__*/React.createElement(Modal, {
    open: open,
    onOk: _onOk,
    onCancel: function onCancel() {
      set_value(value || defaultValue);
      setOpen(false);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "pisell-lowcode-translation-modal"
  }, languageList.map(function (d) {
    return /*#__PURE__*/React.createElement(Form.Item, {
      label: d.text,
      labelCol: {
        span: 24
      },
      key: d.code
    }, /*#__PURE__*/React.createElement(Input, {
      value: _value[d.code],
      onChange: function onChange(e) {
        set_value(_objectSpread(_objectSpread({}, _value), {}, _defineProperty({}, d.code, e.target.value)));
      }
    }));
  }))));
};
export default Translation;